package com.winhc.bigdata.spark.ng.jobs

/**
 * @author: XuJiakai
 * @date: 2021/1/14 19:21
 */
case class args_company_job(tableName: String
                            , md5_fields: Seq[String] //该维度的核心字段
                            , rowkey_udf: String = null //用于自定义rowkey的结构，会覆盖md5_fields的默认rowkey
                            , is_super_filter: Boolean = true //是否不允许主键都为空
                            , where: String = "" // ods层数据的过滤条件
                            , id_user_defined_rowkey: Boolean = false //是否读取ods层的用户自定义rowkey
                           )

object args_company_job {
  val tab_md5_fields = Seq(
    args_company_job("company_app_info", Seq("name"))
    , args_company_job("company_staff", Seq("staff_name"))
    , args_company_job("company_holder", Seq("holder_name"), rowkey_udf = "concat_ws('_',company_id,md5(cleanup(concat_ws('',holder_switch_rowkey(holder_type,holder_id,holder_name)))))", where = " holder_name is not null and trim(holder_name) <> '' AND ( not (holder_type = 2 AND length(holder_id) <> 32)) ")
    , args_company_job("company_icp", Seq("liscense", "domain"))
    , args_company_job("company_tm", Seq("reg_no"))
  )

  def get_args_company_job(tn: String): args_company_job = {
    tab_md5_fields.find(p => tn.equals(p.tableName)).getOrElse(throw new NullPointerException("tn is not fount"))
  }
}
